unit RfidForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  //һֽ
  TByteArr = array of Byte;
  TForm1 = class(TForm)
    btnOpen: TButton;
    btnClose: TButton;
    Label1: TLabel;
    lblState: TLabel;
    GroupBox1: TGroupBox;
    btnStart: TButton;
    btnStopRead: TButton;
    timerUploadMulti: TTimer;
    Memo1: TMemo;
    GroupBox2: TGroupBox;
    btnIdentifySingleTag: TButton;
    txtTag: TEdit;
    Label2: TLabel;
    GroupBox3: TGroupBox;
    btnStop: TButton;
    Button2: TButton;
    btnFastWrite: TButton;
    procedure btnOpenClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btnIdentifySingleTagClick(Sender: TObject);
    procedure btnFastWriteClick(Sender: TObject);
    procedure timerUploadMultiTimer(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopReadClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
    //򿪴豸
    function OpenComm(PortNo:Integer):THandle;stdcall external 'EPCSDK.dll';

    //ر豸
    procedure CloseComm(hCom:THandle);stdcall external 'EPCSDK.dll';


    //ֹͣ豸ȡ
    function StopReading(hCom:THandle;ReaderAddr:Byte):Boolean;stdcall external 'EPCSDK.dll';

    //ָ豸ȡ
    function ResumeReading(hCom:THandle;ReaderAddr:Byte):Boolean;stdcall external 'EPCSDK.dll';

    //ʶ𵥸ǩ
    function IdentifySingleTag(hCom:THandle;tagID:PChar;antennaNo:PByte;ReaderAddr:Byte):Boolean;stdcall external 'EPCSDK.dll';

    //ʶϴĵǩ
    function IdentifyUploadedSingleTag(hCom:THandle;tagID:PChar;devNo:Byte;antennaNo:Byte):Boolean;stdcall external 'EPCSDK.dll';
    //дǩID
    function FastWriteTagID(hCom:THandle;bytesNum:Integer;bytes:TByteArr;ReaderAddr:Byte):Boolean;stdcall external 'EPCSDK.dll';
 var
  Form1: TForm1;
  //ǰӵĴھв˾йϵ
  hcom:THandle;
implementation
//ʮַתbyte
function GetHexByteArr(sRandomPwd:String):TByteArr;
var
 Buf:TByteArr;
begin
   SetLength(Buf, Length(sRandomPwd) div 2);
   HexToBin(PAnsiChar(sRandomPwd), @Buf[0], Length(sRandomPwd) div 2);
   Result:=buf;
end;
//ַת16ַ
function StringToHex(S: String): String;
var I: Integer;
begin
Result:= '';
for I := 1 to (length (S)) do
    if(I<13) then
      begin
        Result:= Result+IntToHex(ord(S[i]),2);
      end;
end;
{$R *.dfm}

procedure TForm1.btnOpenClick(Sender: TObject);
begin
  if hcom<>0 then
    begin
      lblState.Caption:='Ѿ';
      lblState.Refresh;
    end
  else
    begin
      hcom := OpenComm(1);
      if hcom<>0 then
        begin
          lblState.Caption:='Ѵ';
          lblState.Refresh;
          //OpenClose״̬
          btnOpen.Enabled := false;
          btnClose.Enabled :=true;
        end
      else
        begin
          lblState.Caption:='򿪴ʧ';
          lblState.Refresh;
        end;
    end;
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
  if hcom<>0 then
    begin
      CloseComm(hCom);
      hCom := 0;
      lblState.Caption:='ѹر';
      lblState.Refresh;
      //OpenClose״̬
      btnOpen.Enabled := true;
      btnClose.Enabled :=false;
    end
  else
    begin
      lblState.Caption:='ûб';
      lblState.Refresh;
    end;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
    if hcom<>0 then
    begin
      if StopReading(hCom,0) then
        begin
          lblState.Caption:='ͣǩɹ';
          lblState.Refresh;
        end
      else
        begin
          lblState.Caption:='ͣǩʧ';
          lblState.Refresh;
        end;
    end
  else
    begin
      lblState.Caption:='ûб';
      lblState.Refresh;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if hcom<>0 then
    begin
      if ResumeReading(hCom,0) then
        begin
          lblState.Caption:='λͷɹ';
          lblState.Refresh;
        end
      else
        begin
          lblState.Caption:='λͷʧ';
          lblState.Refresh;
        end;
    end
  else
    begin
      lblState.Caption:='ûб';
      lblState.Refresh;
    end;
end;

procedure TForm1.btnIdentifySingleTagClick(Sender: TObject);
var
  tagId:PChar;
  i:Integer;
  t:PByte;
  str:string;
begin
     if hcom<>0 then
    begin
      tagId:=allocmem(12);
      if IdentifySingleTag(hCom,tagId,nil,0) then
        begin
          str := tagId;
          txtTag.Text := StringToHex(str);
          txtTag.Refresh;
          lblState.Caption:='ʶǩɹ';
          lblState.Refresh;
        end
      else
        begin
          lblState.Caption:='ʶǩʧ';
          lblState.Refresh;
        end;
    end
  else
    begin
      lblState.Caption:='ûб';
      lblState.Refresh;
    end;
end;

procedure TForm1.btnFastWriteClick(Sender: TObject);
var
 tagId:TByteArr;
begin
     if hcom<>0 then
    begin
      tagId:= GetHexByteArr(txtTag.Text);
      if FastWriteTagID(hCom,length(tagId),tagId,0) then
        begin
          lblState.Caption:='дɹ';
          lblState.Refresh;
        end
      else
        begin
          lblState.Caption:='дʧ';
          lblState.Refresh;
        end;
    end
  else
    begin
      lblState.Caption:='ûб';
      lblState.Refresh;
    end;
end;

procedure TForm1.timerUploadMultiTimer(Sender: TObject);
var
  tagId:PChar;
  str:string;
begin
  if hcom<>0 then
    begin
      tagId:=allocmem(12);
      if IdentifyUploadedSingleTag(hCom,tagId,0,0) then
        begin
          str:= tagId;
          Memo1.Lines.Add(StringToHex(str));
          lblState.Caption:='дɹ';
          lblState.Refresh;

        end
      else
        begin
          lblState.Caption:='дʧ';
          lblState.Refresh;
        end;
    end
  else
    begin
      lblState.Caption:='ûб';
      lblState.Refresh;
    end;
  
end;

procedure TForm1.btnStartClick(Sender: TObject);
begin
  timerUploadMulti.Enabled := true;
  btnStart.Enabled :=false;
  btnStopRead.Enabled := true;
end;

procedure TForm1.btnStopReadClick(Sender: TObject);
begin
  timerUploadMulti.Enabled := false;
   btnStart.Enabled :=true;
  btnStopRead.Enabled := false;
end;

end.
