package cn.com.cnarj.util;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import cn.com.cnarj.model.pojo.ComInfo;

/**
 * дxmlļ
 * 
 * @author owner
 * 
 */
public class DomParserUtil {

	private static ArrayList list = null;

	private static Map map = null;

	/**
	 * ý,ҽxml
	 */
	public static Document parseXml(String xmlFile) throws Exception {
		// Dom
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder documentBuilder = factory.newDocumentBuilder();
		// xmlļ
		Document document = documentBuilder.parse(xmlFile);

		return document;
	}

	/**
	 * persons.xmlĽڵϢ
	 */
	public void readPersons(String xmlFile) throws Exception {
		Document document = parseXml(xmlFile);
		// xmlļĸԪؽڵ
		Element rootElement = document.getDocumentElement();
		System.out.println(rootElement.getNodeName() + ":"
				+ rootElement.getNodeValue());
		// еperson
		// document.getElementsByTagName("person");
		NodeList personLst = rootElement.getChildNodes();
		System.out.println("personĸ: " + personLst.getLength());
		// ѭÿһperson
		for (int i = 0; i < personLst.getLength(); i++) {

			Node node1 = (Node) personLst.item(i);// ÿһڵ
			if (node1 instanceof Element) {
				Element node = (Element) node1;
				// person
				NamedNodeMap attrLst = node.getAttributes();
				System.out.println("person: ");
				for (int j = 0; j < attrLst.getLength(); j++) {
					Attr attr = (Attr) attrLst.item(j);
					System.out.println(": " + attr.getNodeName() + "ֵ: "
							+ attr.getNodeValue());
				}

				// personԪ
				NodeList personChilds = node.getChildNodes();
				System.out.println("personԪ:");
				for (int k = 0; k < personChilds.getLength(); k++) {
					Node node2 = personChilds.item(k);
					if (node2 instanceof Element) {
						Element eleChild = (Element) node2;
						// Ԫصı
						Text txt = (Text) eleChild.getFirstChild();
						System.out.println("Ԫص: " + eleChild.getNodeName()
								+ ",ıֵ: " + txt.getNodeValue());
					}

				}
			}
		}
	}

	/**
	 * comsconfig.xmlĽڵϢ
	 */
	@SuppressWarnings("unchecked")
	public static ArrayList readXml(String xmlFile) throws Exception {
		Document document = parseXml(xmlFile);
		Element rootElement = document.getDocumentElement();
		list = new ArrayList();
		NodeList comLst = rootElement.getChildNodes();
		for (int i = 0; i < comLst.getLength(); i++) {
			Node node1 = (Node) comLst.item(i);
			if (node1 instanceof Element) {
				Element node = (Element) node1;
				NamedNodeMap attrLst = node.getAttributes();
				map = new HashMap();
				for (int j = 0; j < attrLst.getLength(); j++) {
					Attr attr = (Attr) attrLst.item(j);
					map.put(attr.getNodeName(), attr.getNodeValue());
				}
				list.add(map);
			}
		}
		return list;
	}

	/**
	 * xml
	 */
	public static int createXml(ComInfo[] gy) throws Exception {
		Writer write  = null;
		Writer buffer = null;
		int flag = 0;
		try {
			int ii_row;
			ii_row = gy.length;
			write = new FileWriter("comsconfig.xml");
			buffer = new BufferedWriter(write);
			StringBuffer sb = new StringBuffer();
			sb.append("<?xml version='1.0' encoding='gb2312'?>\n");
			sb.append("<coms>\n");
			for (int i = 0; i < ii_row; i++) {
				sb.append("<com  remoteHost='").append(gy[i].getRemoteHost()).append("'")
				.append(" remotePort='").append(gy[i].getRemotePort()).append("'")
				.append(" bswz='").append(gy[i].getBswz()).append("'").append(" />\n");
			}
			sb.append("</coms>");
			buffer.write(sb.toString());
			flag = 1;
		} catch (Exception e) {
			flag = -1;
		}finally{
			if(buffer != null)
				buffer.close();
			if(write != null)
				write.close();
		}
		return flag ;
	}

}
