package cn.com.cnarj.view.dialog;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;

import cn.com.cnarj.factory.BottonAction;
import cn.com.cnarj.factory.GBC;
import cn.com.cnarj.factory.JDialogFactory;
import cn.com.cnarj.model.pojo.ComInfo;
import cn.com.cnarj.util.DomParserUtil;
import cn.com.cnarj.util.Pubcom;

/**
 * ͷͨѶ˿ںip
 * @author Administrator
 *
 */
public class ComDialog implements JDialogFactory{

	private static ComDialog instance;
	
	private JDialog dialog;
	
	private JPanel panel;//

	private JPanel northPanel;// 

	private JPanel centerPanel;// 

	private JPanel southPanel;// 

	private JTextField baud;// 
	
	private JTextField remoteHost;//Ķip
	
	private JTextField remotePort;//Ķ˿
	
	private JComboBox bswz,jcb_coms;

	private JTable table;

	private Vector titles;
	
	private String[] ls_bswz = {"ڲ",""},ls_coms;
	
	private Vector data;//

	private DefaultTableModel model;

	private JScrollPane scrollPanel;// 
	
	Pubcom pubcom = new Pubcom();
	
	ArrayList la_array = new ArrayList();
	
	Vector data1 = new Vector();
	
	DomParserUtil domutil = new DomParserUtil();
	
	BottonAction bottonaction = new BottonAction(this);
	
	private ComDialog(){
		initTextField();
		init();
	}
	
	public static ComDialog getInstance(){
		if(instance == null){
			instance = new ComDialog();
		}
		return instance;
	}

	public JDialog getJDialog() {
		if(dialog!=null){
			return dialog;
		}
		return null;
	}

	/**
	 * ʼ
	 */
	public JDialogFactory init() {
		if(dialog == null){
			dialog = new JDialog();
			dialog.setTitle("ͨѶ˿ý");
			dialog.setResizable(false);
			dialog.setSize(600, 400);
			dialog.add(createPanel());
			dialog.setLocationRelativeTo(null);
			dialog.setDefaultCloseOperation(dialog.DISPOSE_ON_CLOSE);
			dialog.setModal(true);
			dialog.setVisible(false);
		}
		return this;
	}
	
	/**
	 * ʼıֵ
	 */
	@SuppressWarnings("unchecked")
	public void initTextField() {
		ArrayList list = new ArrayList();
		Map map =null;
		int li_i,li_rows;
		remoteHost = new JTextField(8);
		remotePort = new JTextField(8);
		bswz = new JComboBox(ls_bswz);
		try {
			list = DomParserUtil.readXml("comsconfig.xml");
			li_rows = list.size();
			for(li_i = 0 ;li_i<li_rows ; li_i++){
				map = new HashMap();
				map = (Map)list.get(li_i);
				data = new Vector();
				data.add(map.get("remoteHost")==null? null:map.get("remoteHost").toString());
				data.add(map.get("remotePort")==null? null:map.get("remotePort").toString());
				data.add(map.get("bswz")==null? null:map.get("bswz").toString());
				data1.add(data);
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "ʼıʧܣ");
			e.printStackTrace();
		}
	}

	/**
	 * ,
	 * 
	 * @return
	 */
	public JPanel createPanel() {
		if (panel == null) {
			panel = new JPanel();
			panel.setLayout(new GridBagLayout());
			panel.add(createNorthPanel(), new GBC(0,0));
			panel.add(createCenterPanel(), new GBC(0,1));
			panel.add(createSouthPanel(),new GBC(0,2));
		}
		return panel;
	}

	/**
	 * 
	 * 
	 * @return
	 */
	public JPanel createNorthPanel() {
		if (northPanel == null) {
			northPanel = new JPanel();
//			northPanel.setLayout(new GridBagLayout());
			northPanel.setLayout(new FlowLayout(FlowLayout.LEADING,12,15));
			northPanel.add(new Label("Ķip:"), new GBC(0, 0).setInset(5, 10, 10,
					1));
			northPanel.add(remoteHost, new GBC(1, 0).setInset(5, 1, 10, 6));
			// ------------------
			northPanel.add(new Label("Ķ˿:"), new GBC(2, 0).setInset(5, 10, 10,
					1));
			northPanel.add(remotePort, new GBC(3, 0).setInset(5, 2, 10, 6));
			// ------------------------
			northPanel.add(new Label("ͷλ:"), new GBC(4, 0).setInset(5, 2, 10,
					1));
			northPanel.add(bswz, new GBC(5, 0).setInset(5, 2, 10, 6));
			// -----------
//			northPanel.add(new Label("                 "), new GBC(5, 0).setInset(5, 2, 10,
//					1));
			northPanel.setPreferredSize(new Dimension(530, 120));
			northPanel
					.setBorder(BorderFactory.createTitledBorder("ĶϢ"));
		}
		return northPanel;
	}

	/**
	 * 
	 * 
	 * @return
	 */
	public JPanel createCenterPanel() {
		if (centerPanel == null) {
			centerPanel = new JPanel();
			centerPanel.setLayout(new BorderLayout());
			centerPanel.add(createScrollPanel());
			centerPanel.setPreferredSize(new Dimension(530, 180));
		}
		return centerPanel;
	}

	/**
	 * 
	 * 
	 * @return
	 */
	public JPanel createSouthPanel() {
		if (southPanel == null) {
			southPanel = new JPanel();
			southPanel.setLayout(new GridBagLayout());
			southPanel.add(createButton(""), new GBC(0, 0).setInset(20, 15,
					10, 70));
			southPanel.add(createButton("ɾ"), new GBC(1, 0).setInset(20, 25,
					10, 70));
			southPanel.setPreferredSize(new Dimension(530, 60));
		}
		return southPanel;
	}

	/**
	 * 
	 * 
	 * @return
	 */
	public JTable createTable() {
		
		titles = new Vector();
		titles.add("Ķip");
		titles.add("Ķ˿");
		titles.add("ͷλ");
		
		if (table == null) {
			model = new DefaultTableModel(data1, titles);
			table = new JTable(model);
			table.setAutoResizeMode(table.AUTO_RESIZE_ALL_COLUMNS);
		}
		return table;
	}

	/**
	 * 壬ӱϢ
	 * 
	 * @return
	 */
	public JScrollPane createScrollPanel() {
		if (scrollPanel == null) {
			scrollPanel = new JScrollPane(createTable());
		}
		return scrollPanel;
	}

	
	/**
	 * ť÷
	 * 
	 * @param name
	 * @return
	 */
	public JButton createButton(String name) {
		JButton button = new JButton(name);
		button.addActionListener(bottonaction);
		return button;
	}
	
	/**
	 * 
	 * 
	 * @param name
	 * @return
	 */
	public void add(){
		String remoteHost = "";
		String remotePort = "";
		data = new Vector();
		remoteHost = this.remoteHost.getText().trim();
		remotePort = this.remotePort.getText().trim();
		if (remoteHost == null || "".equals(remoteHost)){
			JOptionPane.showMessageDialog(null, "Ķip!");
			return;
		}
		if (remotePort == null || "".equals(remotePort)){
			JOptionPane.showMessageDialog(null, "Ķ˿!");
			return;
		}
		data.add(remoteHost);
		data.add(remotePort);
		data.add(bswz.getSelectedItem());
		data1.add(data);
		model.setDataVector(data1, titles);
		//´xmlĵ
		int ii_i,ii_row;
		ii_row = table.getRowCount();
		ComInfo[] cominfo = new ComInfo[ii_row];
		for(ii_i = 0 ; ii_i < ii_row ; ii_i++){
			cominfo[ii_i] = new ComInfo();
			cominfo[ii_i].setRemoteHost(table.getValueAt(ii_i, 0).toString());
			cominfo[ii_i].setRemotePort(table.getValueAt(ii_i, 1).toString());
			cominfo[ii_i].setBswz(table.getValueAt(ii_i, 2).toString());
		}
		try {
			int flag = DomParserUtil.createXml(cominfo);
			if(flag == 1){
				JOptionPane.showMessageDialog(null, "ɹ!");
			}else{
				JOptionPane.showMessageDialog(null, "ʧ!");
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "ʧ!");
			e.printStackTrace();
		}
	}
	/**
	 * ɾ
	 * 
	 * @param name
	 * @return
	 */
	public void del(){
		int ii_row;
		ii_row = table.getSelectedRow();
		String is_a = "";
		if (ii_row != -1){
			is_a = table.getValueAt(ii_row, 1).toString();  //õѡеĵ2С
			data1.remove(ii_row);
			model.setDataVector(data1, titles);
			table = new JTable(model);
			//´xmlĵ
			int ii_i;
			ii_row = table.getRowCount();
			ComInfo[] cominfo = new ComInfo[ii_row];
			for(ii_i = 0 ; ii_i < ii_row ; ii_i++){
				cominfo[ii_i] = new ComInfo();
				cominfo[ii_i].setRemoteHost(table.getValueAt(ii_i, 0).toString());
				cominfo[ii_i].setRemotePort(table.getValueAt(ii_i, 1).toString());
				cominfo[ii_i].setBswz(table.getValueAt(ii_i, 2).toString());
			}
			try {
				int flag = DomParserUtil.createXml(cominfo);
				if(flag == 1){
					JOptionPane.showMessageDialog(null, "ɾɹ!");
				}else{
					JOptionPane.showMessageDialog(null, "ɾʧ!");
				}
			} catch (Exception e) {
				JOptionPane.showMessageDialog(null, "ɾʧ!");
				e.printStackTrace();
			}
		}else{
			JOptionPane.showMessageDialog(null, "ѡһм¼");
		}
	}
	/**
	 * 
	 * 
	 * @param name
	 * @return
	 */
	public void save(){
		int ii_i,ii_row;
		ii_row = table.getRowCount();
		ComInfo[] cominfo = new ComInfo[ii_row];
		for(ii_i = 0 ; ii_i < ii_row ; ii_i++){
			cominfo[ii_i] = new ComInfo();
			cominfo[ii_i].setRemoteHost(table.getValueAt(ii_i, 0).toString());
			cominfo[ii_i].setRemotePort(table.getValueAt(ii_i, 1).toString());
			cominfo[ii_i].setBswz(table.getValueAt(ii_i, 2).toString());
		}
		try {
			int flag = DomParserUtil.createXml(cominfo);
			if(flag == 1){
				JOptionPane.showMessageDialog(null, "Ϣɹ!");
			}else{
				JOptionPane.showMessageDialog(null, "Ϣʧ!");
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Ϣʧ!");
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		new ComDialog().getInstance().getJDialog().setVisible(true);
	}
}
