// TestUseEPCSDKDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestUseEPCSDK.h"
#include "TestUseEPCSDKDlg.h"
#include "EPCSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestUseEPCSDKDlg dialog

CTestUseEPCSDKDlg::CTestUseEPCSDKDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestUseEPCSDKDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestUseEPCSDKDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_handle = INVALID_HANDLE_VALUE;
}

void CTestUseEPCSDKDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestUseEPCSDKDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestUseEPCSDKDlg, CDialog)
	//{{AFX_MSG_MAP(CTestUseEPCSDKDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Open, OnOpen)
	ON_BN_CLICKED(IDC_Close, OnClose)
	ON_BN_CLICKED(IDC_ReadFirmVersion, OnReadFirmVersion)
	ON_BN_CLICKED(IDC_ResumeReadingTag, OnResumeReadingTag)
	ON_BN_CLICKED(IDC_StopReadingTag, OnStopReadingTag)
	ON_BN_CLICKED(IDC_StartReadingMultiTags, OnStartReadingMultiTags)
	ON_BN_CLICKED(IDC_StartReadingSingleTag, OnStartReadingSingleTag)
	ON_BN_CLICKED(IDC_StopReadingMultiTags, OnStopReadingMultiTags)
	ON_BN_CLICKED(IDC_StopReadingSingleTag, OnStopReadingSingleTag)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_Clear, OnClear)
	ON_BN_CLICKED(IDC_FastWriteTag, OnFastWriteTag)
	ON_BN_CLICKED(IDC_Initialize, OnInitializeTag)
	ON_BN_CLICKED(IDC_Lock, OnLockTag)
	ON_BN_CLICKED(IDC_Destroy, OnDestroyTag)
	ON_BN_CLICKED(IDC_WriteTagSingleWord, OnWriteTagSingleWord)
	ON_BN_CLICKED(IDC_ReadTagContent, OnReadTagContent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestUseEPCSDKDlg message handlers

BOOL CTestUseEPCSDKDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestUseEPCSDKDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestUseEPCSDKDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestUseEPCSDKDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestUseEPCSDKDlg::OnOpen() 
{
	if(m_handle == INVALID_HANDLE_VALUE)
	{
		m_handle = ::OpenComm(1);
		if(m_handle != INVALID_HANDLE_VALUE)
            SetDlgItemText(IDC_OperationList, "򿪴1ɹ");
        else
			SetDlgItemText(IDC_OperationList, "򿪴1ʧܣ");
	}
	else
		SetDlgItemText(IDC_OperationList, "1Ѵ򿪣");
}

void CTestUseEPCSDKDlg::OnClose() 
{
	if(m_handle != INVALID_HANDLE_VALUE)
	{
        ::CloseComm(m_handle);
        m_handle = INVALID_HANDLE_VALUE;
        SetDlgItemText(IDC_OperationList, "رմ1ɹ");
	}
    else
		SetDlgItemText(IDC_OperationList, "1δ򿪣");
}

void CTestUseEPCSDKDlg::OnReadFirmVersion() 
{
	int mainVersion = 0;
    int subVersion = 0;
    if(::ReadFirmwareVersion(m_handle, &mainVersion, &subVersion,0))
	{
		CString str;
		str.Format("Firmware version: %d.%d", mainVersion, subVersion);
		SetDlgItemText(IDC_OperationList, str);
	}
    else
		SetDlgItemText(IDC_OperationList, "ȡFirmware汾ʧܣ");
}

void CTestUseEPCSDKDlg::OnStopReadingTag() 
{
	if(::StopReading(m_handle,0))
		SetDlgItemText(IDC_OperationList, "ͣǩɹ");
    else
		SetDlgItemText(IDC_OperationList, "ͣǩʧܣ");
}

void CTestUseEPCSDKDlg::OnResumeReadingTag() 
{
	if(::ResumeReading(m_handle,0))
		SetDlgItemText(IDC_OperationList, "λͷɹ");
    else
		SetDlgItemText(IDC_OperationList, "λͷʧܣ");
}

#define	TIMER_ReadSingleTag		1000
#define	TIMER_ReadMultiTags		1001

void CTestUseEPCSDKDlg::OnStartReadingSingleTag() 
{
	SetTimer(TIMER_ReadSingleTag, 500, NULL);
}

void CTestUseEPCSDKDlg::OnStopReadingSingleTag() 
{
	KillTimer(TIMER_ReadSingleTag);
	SetDlgItemText(IDC_OperationList, "ֹͣ");
}

void CTestUseEPCSDKDlg::OnStartReadingMultiTags() 
{
//	SetTimer(TIMER_ReadMultiTags, 3000, NULL);
  if(LockPassWordTag(m_handle,0x12,0x34,0x56,0x78,0x02,0))// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK  
     	SetDlgItemText(IDC_OperationList, "EPCɹ");
  else  
	    SetDlgItemText(IDC_OperationList, "EPCʧܣ");
}
void CTestUseEPCSDKDlg::OnStopReadingMultiTags() 
{
//	KillTimer(TIMER_ReadMultiTags);
//	SetDlgItemText(IDC_OperationList, "ֹͣ࿨");
 if(UnlockPassWordTag(m_handle,0x12,0x34,0x56,0x78,0x02,0))
	 	SetDlgItemText(IDC_OperationList, "EPCɹ");
  else  
	    SetDlgItemText(IDC_OperationList, "EPCʧܣ");
}

void CTestUseEPCSDKDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == TIMER_ReadSingleTag)
	{
		BYTE id[12];    // Tag id length is 12
		BYTE devNo = 0;
		BYTE antennaNo = 0;
		if(IdentifyUploadedSingleTag(m_handle, id, &devNo, &antennaNo))
		{
			// Transfer tag ID to Hex Format
			CString strID;
			CString strTmp;
			for(int i = 0; i < 12; i++)
			{
				strTmp.Format("%02X ", id[i]);
				strID += strTmp;
			}
			// Device No
			CString strDevNo;
			strDevNo.Format("%d", devNo);
			// Antenna No
			CString strAntennaNo;
			strAntennaNo.Format("%d", antennaNo);
			// Display
			SetDlgItemText(IDC_OperationList, strID + "    Device No: " + strDevNo + "    Antenna No: " + strAntennaNo);
		}
		else
			SetDlgItemText(IDC_OperationList, "ʶǩʧܣ");
	}
	else if(nIDEvent == TIMER_ReadMultiTags)
	{
		BYTE idNum = 0;	// Max tag num is 200
		BYTE ids[12 * 200];	// The id length of each is 12, so 12 * 200 bytes is needed
		BYTE devNos[200];
		BYTE antennaNos[200];
		if(::IdentifyUploadedMultiTags(m_handle, &idNum, ids, devNos, antennaNos))
		{
			// Transfer to Hex Format
			CString str;
			CString strTmp;
			for(int j = 0; j < idNum; j++)
			{
				strTmp.Format("%d ", j);
				str += ("No." + strTmp + ": ");
				for(int i = 0; i < 12; i++)
				{
					strTmp.Format("%02X ", ids[12 * j + i]);
					str += strTmp;
				}
				// Device No
				CString strDevNo;
				strDevNo.Format("%d", devNos[j]);
				str += ("    Device No: " + strDevNo);
				// Antenna No
				CString strAntennaNo;
				strAntennaNo.Format("%d", antennaNos[j]);
				str += ("    Antenna No: " + strAntennaNo);
				// Change Line
				str += "\r\n";
			}
			// Display
			SetDlgItemText(IDC_OperationList, str);
		}
	}
	else
		CDialog::OnTimer(nIDEvent);
}

void CTestUseEPCSDKDlg::OnClear() 
{
	SetDlgItemText(IDC_OperationList, "");
}

void CTestUseEPCSDKDlg::OnFastWriteTag() 
{
	BYTE id[4] = {0x00, 0x11, 0x22, 0x33};
	if(::FastWriteTagID(m_handle, 4, id,0))
		SetDlgItemText(IDC_OperationList, "дɹ");
    else
		SetDlgItemText(IDC_OperationList, "дʧܣ");
}

void CTestUseEPCSDKDlg::OnWriteTagSingleWord()
{
	BYTE Writedata[4]={0x00, 0x11, 0x22, 0x33};
//	if(::WriteTagSingleWord(m_handle, 0x01, 0x02, 0xFF, 0xFF,0))	// EPCַ02д1(2ֽ)
//		SetDlgItemText(IDC_OperationList, "EPCַ02д1(2ֽ)ݳɹ");
//	else
//		SetDlgItemText(IDC_OperationList, "дǩʧܣ");
	if(::FastWriteTag(m_handle, 03, 00, 2, Writedata,0))
       	SetDlgItemText(IDC_OperationList, "userַ00д2(4ֽ)ݳɹ");
	else
		SetDlgItemText(IDC_OperationList, "userַ00д2(4ֽ)ʧܣ");  
}

void CTestUseEPCSDKDlg::OnReadTagContent()
{
	BYTE data[2];
	if(::ReadTag(m_handle, 0x01, 0x03, 1, data,0))	// EPCַ02ʼ1(2ֽ)
	{
		CString strData;
		strData.Format("%02X %02X ", data[0], data[1]);
		SetDlgItemText(IDC_OperationList, "EPCַ02ʼ1(2ֽ)ݳɹ    "+strData);
	}
	else
		SetDlgItemText(IDC_OperationList, "ǩʧܣ");
}

void CTestUseEPCSDKDlg::OnInitializeTag() 
{
	if(::InitializeTag(m_handle,0))
		SetDlgItemText(IDC_OperationList, "ʼǩɹ");
	else
		SetDlgItemText(IDC_OperationList, "ʼǩʧܣ");
}

void CTestUseEPCSDKDlg::OnLockTag() 
{
//	if(::LockTag(m_handle, 5))	// Lock All
//		SetDlgItemText(IDC_OperationList, "ǩɹ");
//	else
//		SetDlgItemText(IDC_OperationList, "ǩʧܣ");
//ReadByEpcID(HANDLE hCom, BYTE memBank, BYTE address, BYTE WordCount,const BYTE* EpcID,BYTE* data);
BYTE data[16];
BYTE EpcID[12]={0X12,0X34,0X56,0X78,0X99,0X99,0X11,0X11,0X00,0X11,0X22,0X33};
if(::ReadByEpcID(m_handle, 2, 2, 4,EpcID,data,0))								//TID 
    SetDlgItemText(IDC_OperationList, "ָEPCTIDɹ");
else 
    SetDlgItemText(IDC_OperationList, "ָEPCTIDʧܣ");
}

void CTestUseEPCSDKDlg::OnDestroyTag() 
{
//	if(::KillTag(m_handle, 0xFF, 0xFF, 0xFF, 0xFF))	// Lock All
//		SetDlgItemText(IDC_OperationList, "ٱǩɹ");
//	else
//		SetDlgItemText(IDC_OperationList, "ٱǩʧܣ"); 
//   WriteByEpcID(HANDLE hCom, BYTE memBank, BYTE address, BYTE WordCount,const BYTE* EpcID,BYTE* data); 
BYTE data[2]={0x12,0x34};
BYTE EpcID[12]={0X12,0X34,0X56,0X78,0X99,0X99,0X11,0X11,0X00,0X11,0X22,0X33};
if(::WriteByEpcID(m_handle, 3, 0, 2,EpcID,data,0))								  //USER 
    SetDlgItemText(IDC_OperationList, "ָEPCдǩɹ");
else 
    SetDlgItemText(IDC_OperationList, "ָEPCдǩʧܣ");
}

