package cn.com.cnarj.view.dialog;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;

import cn.com.cnarj.factory.GBC;
import cn.com.cnarj.factory.JDialogFactory;

/**
 * ڶԻ
 * @author hedan
 * @since 2012-3-14
 * -
 *
 */
public class AboutDialog implements JDialogFactory {

private static AboutDialog instance;
	
	private JDialog dialog;
	
	private JPanel panel;//
	
	private Font font = new Font("", 1 ,12) ;

	private JPanel northPanel;// 
	
	/**
	 * ģʽ˽л캯
	 */
	private AboutDialog(){
		init();
	}
	
	/**
	 * ùڶԻʵ
	 * @return
	 */
	public static AboutDialog getInstance(){
		if(instance == null){
			instance = new AboutDialog();
		}
		return instance;
	}

	public JDialog getJDialog() {
		if(dialog!=null){
			return dialog;
		}
		return null;
	}

	/**
	 * ʼ
	 */
	public JDialogFactory init() {
		if(dialog == null){
			dialog = new JDialog();
			dialog.setTitle("ϵͳ");
			dialog.setResizable(false);
			dialog.setSize(350, 250);
			dialog.add(createPanel());
			dialog.setLocationRelativeTo(null);
			dialog.setDefaultCloseOperation(dialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(false);
		}
		return this;
	}
	

	/**
	 * ,
	 * 
	 * @return
	 */
	public JPanel createPanel() {
		if (panel == null) {
			panel = new JPanel();
			panel.add(createNorthPanel());
		}
		return panel;
	}

	/**
	 * 
	 * 
	 * @return
	 */
	public JPanel createNorthPanel() {
		if (northPanel == null) {
			northPanel = new JPanel();
			northPanel.setLayout(new GridBagLayout());
			northPanel.setFont(font);
			northPanel.add(new Label("˾:ϰܿƼչɷ޹˾"), new GBC(0, 0).setInset(5, 10, 10,2));
			northPanel.add(new Label("    ַ:ɳ·68Ż˫12¥"), new GBC(0, 2).setInset(5, 10, 10,2));
			northPanel.add(new Label("ϵ绰:0731-84159925"), new GBC(0, 4).setInset(5, 2, 10,2));
			northPanel.add(new Label(" ϵ :ջ"), new GBC(0, 6).setInset(5, 10, 10,2));
			northPanel.add(new Label("    :1.0"), new GBC(0, 8).setInset(5, 10,10, 2));
			northPanel.setBorder(BorderFactory.createTitledBorder(""));
		}
		return northPanel;
	}

}
